package fr.gouv.vitamui.pastis.external.model.seda;

import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.util.List;
import java.util.stream.Stream;

@Data
@Getter
@Setter
public class SedaNode {
    private String Name;
    private String Element;
    private String Cardinality;
    private String Type;
    private String Choice;
    private String Extensible;
    private List<String> Enumeration;
    private String Definition;
    private String Collection;
    private List<SedaNode> Children;


    public Stream<SedaNode> flattened() {
        return Stream.concat(
                Stream.of(this),
                Children.stream().flatMap(SedaNode::flattened));
    }
}
