package fr.gouv.vitamui.pastis.external;

import fr.gouv.vitamui.pastis.external.model.profiles.PastisProfile;
import org.json.JSONArray;
import org.json.JSONObject;
import org.junit.Test;
import org.junit.jupiter.api.Assertions;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.RequestBuilder;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;

import java.util.Arrays;
import java.util.List;

@RunWith(SpringRunner.class)
@TestPropertySource(locations = "/application.properties")
@AutoConfigureMockMvc
@SpringBootTest
public class ProfileControllerTest {

    private static final Logger LOGGER = LoggerFactory.getLogger(ProfileControllerTest.class);

    @Autowired
    private MockMvc mockMvc;

    private MockHttpServletResponse mockHttpServletResponse;

    @Test
    public void getProfiles() throws Exception {
        RequestBuilder requestBuilder = MockMvcRequestBuilders.get("/getprofiles");
        mockHttpServletResponse = mockMvc.perform(requestBuilder).andReturn().getResponse();
        String resBody = mockHttpServletResponse.getContentAsString();
        LOGGER.info("response = {}", resBody);
        Assertions.assertEquals(200, mockHttpServletResponse.getStatus());
    }

    @Test
    public void test() throws Exception {
        RequestBuilder requestBuilder = MockMvcRequestBuilders.get("/test");
        mockHttpServletResponse = mockMvc.perform(requestBuilder).andReturn().getResponse();
        String resBody = mockHttpServletResponse.getContentAsString();
        LOGGER.info("response = {}", resBody);
        Assertions.assertEquals(200, mockHttpServletResponse.getStatus());
        Assertions.assertEquals("Pastis API is listening...", resBody);
    }

    @Test
    public void getFile() throws Exception {
        RequestBuilder requestBuilder = MockMvcRequestBuilders.get("/getfile");
        mockHttpServletResponse = mockMvc.perform(requestBuilder).andReturn().getResponse();
        String resBody = mockHttpServletResponse.getContentAsString();
        LOGGER.info("response = {}", resBody);
        Assertions.assertEquals(200, mockHttpServletResponse.getStatus());
    }

    @Test
    public void testProfiles() throws Exception {
        int i=0;
        RequestBuilder requestBuilder = MockMvcRequestBuilders.get("/getprofiles");
        mockHttpServletResponse = mockMvc.perform(requestBuilder).andReturn().getResponse();
        String resBody = mockHttpServletResponse.getContentAsString();
        JSONArray jsonArray= new JSONArray(resBody);
        while (i<jsonArray.length()-1){
            JSONObject jsonObject = jsonArray.getJSONObject(i);
            PastisProfile pastisProfile = new PastisProfile();
            pastisProfile.deserialise(jsonObject);
            List profilesNok = Arrays.asList("ProfileJson.json");
            if(!profilesNok.contains(pastisProfile.getFileName())){
                requestBuilder = MockMvcRequestBuilders.post("/edit").param("id", pastisProfile.getId().toString());
                mockHttpServletResponse = mockMvc.perform(requestBuilder).andReturn().getResponse();
                resBody = mockHttpServletResponse.getContentAsString();
                LOGGER.info("response = {}", resBody);
                Assertions.assertEquals(200, mockHttpServletResponse.getStatus());
            }
            i++;
        }
    }

}
