package fr.gouv.vitamui.pastis.model.profiles;

import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.json.JSONObject;

import java.sql.Timestamp;
import java.util.Random;

@Data@Getter@Setter@NoArgsConstructor
public class PastisProfile {

    String type;
    Long id;
    String fileName;
    String baseName;
    String status;
    String lastModified;

    public PastisProfile(String fileName,String status, Long lastModified) {
        this.type = this.getFileType(fileName);
        this.id = Math.abs(new Random().nextLong()) / 1000;
        this.fileName = fileName;
        this.baseName = getFileBaseName(fileName);
        this.status = status;
        this.lastModified = new Timestamp(lastModified).toString();
    }

    private String getFileType(String fileName){
        String[] tokens = fileName.split("\\.(?=[^\\.]+$)");
        return tokens[1].equals("rng") ? "PA" : "PUA";
    }

    private String getFileBaseName(String fileName){
        String[] tokens = fileName.split("\\.(?=[^\\.]+$)");
        return tokens[0];
    }


    public void deserialise(JSONObject jsonObject) {

        this.setId((Long) jsonObject.get("id"));
        this.setStatus((String) jsonObject.get("status"));
        this.setLastModified( (String)  jsonObject.get("lastModified"));
        this.setFileName( (String)  jsonObject.get("fileName"));
        this.setBaseName( (String)  jsonObject.get("baseName"));
        this.setType( (String)  jsonObject.get("type"));
    }
}

